/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: Instance.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_INSTANCE_HPP_
#define _TOPS_INSTANCE_HPP_

#include "tops/common/Printable.hpp"

#include <string>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

namespace tops {

	class ProductionRule;
	class ProductionSystem;
	class UnificatedElements;
	class UnificationState;
	typedef boost::shared_ptr<UnificationState> UnificationStatePtr;
	class WMElement;

	class Instance;
	typedef boost::shared_ptr<Instance> InstancePtr;

	/**
	 * 単一化することにより生成されたインスタンスです。
	 *
	 * @author トゥイー
	 */
	class Instance : public boost::noncopyable, public Printable {
	private:
		ProductionRule& m_sourceRule;
		UnificationStatePtr m_state;

	public:
		/**
		 * インスタンスを構築します。
		 */
		Instance(ProductionRule& sourceRule, const UnificationStatePtr& state);

	public:
		/**
		 * インスタンス元となるプロダクションルールを取得します。
		 */
		ProductionRule& getSourceProductionRule() const {
			return m_sourceRule;
		}

		/**
		 * インスタンス元となるワーキングメモリ要素列を取得します。
		 */
		const UnificatedElements& getSourceElements() const;

		/**
		 * インスタンス元となるワーキングメモリ要素を取得します。
		 */
		WMElement* operator[](const std::string& label) const;

		/**
		 * サイズを取得します。
		 */
		size_t size() const;

		/**
		 * インスタンス元となるワーキングメモリ要素を取得します。
		 */
		WMElement* operator[](size_t i) const;

	public:
		/**
		 * 操作を発火します。
		 *
		 * @param system 操作対象となるプロダクションシステムを指定します。
		 *
		 * @return 操作が成功した場合はtrueを、失敗した場合はfalseを返します。
		 */
		bool fire(ProductionSystem& system);

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
